Attribute VB_Name = "Sample"
'===================================================================
' Apci8308s.bas
'-------------------------------------------------------------------
' aPCI-8308 
' Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
' ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
'===================================================================
Option Explicit

Private Const szApci8308 = "aPCI-8308"
Private Const BUFSIZE = 512                 ' Mp̃obt@MAX
'===================================================================
' Jn
'===================================================================
Private Sub Main()
    Dim strbuf As String
    Dim dwDllVer As Long, dwDrvVer As Long  ' DLL, Drivero[W
    Dim wLogSlot As Integer                 ' foCXi[
    Dim ri As APCI8308_RESOURCE             ' \[X
    Dim dwSwVal As Long                     ' armli[
    Dim Mode As SIOMODE                     ' ʐMi[
    Dim Status As SIOSTATUS                 ' ʐMԂi[
    Dim Buff(1 To BUFSIZE) As Byte          ' Mp̃obt@
    Dim i As Integer
    Dim TxSize As Long

    '---------------------------------------------------------------
    ' DLL̎gp錾
    '---------------------------------------------------------------
    If Apci8308wDllOpen() = False Then
        ErrorMessage (APCI8308_SLOT_AUTO)
        Exit Sub
    End If

    ResultMessage ("DLL[h܂B")

    '---------------------------------------------------------------
    ' DLL,VxD̃o[Wԍ擾
    '---------------------------------------------------------------
    If Apci8308wGetVersion(dwDllVer, dwDrvVer) = False Then
        ErrorMessage (APCI8308_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "o[Wԍ擾" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
       
    ResultMessage (strbuf)

    '---------------------------------------------------------------
    ' foCX̎gp錾
    '---------------------------------------------------------------
    wLogSlot = APCI8308_SLOT_AUTO           ' gp̃foCXT܂B
                                            ' ꍇA̎̃foCXi[܂B

    If Apci8308wCreate(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "foCX̎gp錾" + Chr(10) + Chr(10) + _
             "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

    '---------------------------------------------------------------
    ' \[X擾
    '---------------------------------------------------------------
    If Apci8308wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "\[X擾" + Chr(10) + _
             "NumPorts   : " + Str(ri.dwIOPortLength(1)) + Chr(10) + _
             "IO Address : &H" + Hex(ri.dwIOPortBase(1)) + _
             "-&H" + Hex(ri.dwIOPortBase(1) + ri.dwIOPortLength(1) - 1) + Chr(10) + _
             "IRQ        : " + Str(ri.dwIRQRegisters(1))

    ResultMessage (strbuf)

    '---------------------------------------------------------------
    ' BSNXCb`l擾
    '---------------------------------------------------------------
    If Apci8308wGetSwitchValue(wLogSlot, dwSwVal) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    strbuf = "BSN :" + Str(dwSwVal)
    ResultMessage (strbuf)

    '---------------------------------------------------------------
    ' VAʐMJni`lPj
    '---------------------------------------------------------------
    Mode.Baud = APCI8308_SIO_BPS115200      ' 11520bps
    Mode.WordSize = APCI8308_SIO_CB8        ' LN^ 8bit
    Mode.Parity = APCI8308_SIO_PNONE        ' peB
    Mode.StopBits = APCI8308_SIO_S1         ' Xgbvrbg 1bit

    If Apci8308wSioStart(wLogSlot, APCI8308_SIO_CH1, Mode) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "ȉ̏ŒʐMJn܂" + Chr(10) + _
             "`l 1" + Chr(10) + _
             "ʐMx 115200bps" + Chr(10) + _
             "LN^ 8bit" + Chr(10) + _
             "peB " + Chr(10) + _
             "Xgbvrbg 1bit"
    ResultMessage (strbuf)

    '---------------------------------------------------------------
    ' ʐMobt@Zbg
    '---------------------------------------------------------------
    If Apci8308wSioReset(wLogSlot, APCI8308_SIO_CH1) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("ʐMobt@Zbg܂")

    '---------------------------------------------------------------
    ' f[^M
    '---------------------------------------------------------------
    TxSize = 10
    For i = 1 To 10
        Buff(i) = Asc("0") + (i - 1) ' 0 ` 9
    Next i

    If Apci8308wSioWrite(wLogSlot, APCI8308_SIO_CH1, Buff, TxSize) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("f[^M܂")

    '---------------------------------------------------------------
    ' ʐMXe[^X擾
    '---------------------------------------------------------------
    If Apci8308wSioGetStatus(wLogSlot, APCI8308_SIO_CH1, Status) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "ʐMXe[^X擾܂" + Chr(10) + _
             "Mf[^F" + Str(Status.RxSize)

    ResultMessage (strbuf)

    '---------------------------------------------------------------
    ' Mf[^ꍇMs
    '---------------------------------------------------------------
    If Status.RxSize <> 0 Then
        If BUFSIZE < Status.RxSize Then Status.RxSize = BUFSIZE
        If Apci8308wSioRead(wLogSlot, APCI8308_SIO_CH1, Buff, Status.RxSize) = False Then
            ErrorMessage (wLogSlot)
            Exit Sub
        End If

        strbuf = "f[^M܂" + Chr(10) + _
                 "Mf[^F" + Str(Status.RxSize) + Chr(10) + _
                 "Mf[^F" + Chr(10)

        For i = 1 To Status.RxSize
            strbuf = strbuf + Chr(Buff(i))
        Next

        ResultMessage (strbuf)
    End If

    '---------------------------------------------------------------
    ' ʐMI
    '---------------------------------------------------------------
    If Apci8308wSioStop(wLogSlot, APCI8308_SIO_CH1) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    ResultMessage ("ʐM~܂")

    '---------------------------------------------------------------
    ' foCX̎gpI
    '---------------------------------------------------------------
    If Apci8308wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "foCX̎gpI" + Chr(10) + Chr(10) + _
             "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

    '---------------------------------------------------------------
    ' DLL̃A[h
    '---------------------------------------------------------------
    Apci8308wDllClose
End Sub
'===================================================================
' ʂ\
'===================================================================
Private Sub ResultMessage(lpszbuf As String)
    
    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub
'===================================================================
' G[bZ[W\
'===================================================================
Private Sub ErrorMessage(wLogSlot As Integer)
    
    Dim dwRes As Long
    Dim szbuf As String
    
    dwRes = Apci8308wGetLastError(wLogSlot)

    Select Case dwRes
    Case APCI8308_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aPCI-8308 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub



