Attribute VB_Name = "Wrapper"
'============================================================================
' Apci8308w.bas
'----------------------------------------------------------------------------
' aPCI-8308 
' Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'============================================================================
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI8308_DLL_NAME = "Apci8308.dll"   ' DLL
Global Const APCI8308_ERR_WRAPDLL = -1            ' bp[֐G[
Dim hDLL As Long                                  ' DLLւ̃nh

'============================================================================
'    DLL۰(۰ގʹװƂ)
'    
' ߂l     True
'        s    False
'============================================================================
Function Apci8308wDllOpen() As Boolean
    Apci8308wDllOpen = True
    If hDLL = 0 Then
        hDLL = LoadLibrary(APCI8308_DLL_NAME)
        If hDLL <> 0 Then
            If Apci8308wGetDllExportFunc() = True Then
                Exit Function
            Else
                ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
                Apci8308wDllClose
            End If
        End If
    End If
    Apci8308wDllOpen = False
End Function
'============================================================================
'    DLL۰(۰ގʹװƂ)
'    
' ߂l  True
'        s False
'============================================================================
Function Apci8308wDllClose() As Boolean
    Apci8308wDllClose = True
    If hDLL = 0 Then
        If FreeLibrary(hDLL) = 0 Then
            hDLL = 0
            Exit Function
        End If
    End If
    Apci8308wDllClose = False
End Function
'============================================================================
'     DLL,Driver ̃o[W擾
'     pdwDllVer     DLL o[Wԍi[̈
'         pdwDrvVer     DRV o[Wԍi[̈
'  ߂l  True
'         s False
'============================================================================
Public Function Apci8308wGetVersion(ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Boolean
    Apci8308wGetVersion = False
    If hDLL = 0 Then Exit Function
    If Apci8308GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function
    Apci8308wGetVersion = True
End Function
'============================================================================
'    foCXgp錾
'    pwLogSlot      gpfoCXԍi[̈
' ߂l  True
'        s False
'============================================================================
Public Function Apci8308wCreate(ByRef pwLogSlot As Integer) As Boolean
    Apci8308wCreate = False
    If hDLL = 0 Then Exit Function
    If Apci8308Create(pwLogSlot) = 0 Then Exit Function
    Apci8308wCreate = True
End Function
'============================================================================
'    foCXJ
'    wLogSlot       foCX̘_Xbgԍ
' ߂l  True
'        s False
'============================================================================
Public Function Apci8308wClose(ByVal wLogSlot As Integer) As Boolean
    Apci8308wClose = False
    If hDLL = 0 Then Exit Function
    If Apci8308Close(wLogSlot) = 0 Then Exit Function
    Apci8308wClose = True
End Function
'============================================================================
'    \[X擾
'    wLogSlot       foCX̘_Xbgԍ
'        pRes           \[Xi[̈
' ߂l  True
'        s False
'============================================================================
Public Function Apci8308wGetResource(ByVal wLogSlot As Integer, ByRef pRes As APCI8308_RESOURCE) As Boolean
    Apci8308wGetResource = False
    If hDLL = 0 Then Exit Function
    If Apci8308GetResource(wLogSlot, pRes) = 0 Then Exit Function
    Apci8308wGetResource = True
End Function
'============================================================================
'    arml擾
'    wLogSlot       foCX̘_Xbgԍ
'        pdwSwitchValue armli[̈
' ߂l  True
'        s False
'============================================================================
Public Function Apci8308wGetSwitchValue(ByVal wLogSlot As Integer, ByRef pdwSwitchValue As Long) As Boolean
    Apci8308wGetSwitchValue = False
    If hDLL = 0 Then Exit Function
    If Apci8308GetSwitchValue(wLogSlot, pdwSwitchValue) = 0 Then Exit Function
    Apci8308wGetSwitchValue = True
End Function
'============================================================================
'    G[擾
'    wLogSlot       foCX̘_Xbgԍ
' ߂l G[
'============================================================================
Public Function Apci8308wGetLastError(ByVal wLogSlot As Integer) As Long
    Apci8308wGetLastError = APCI8308_ERR_WRAPDLL
    If hDLL = 0 Then
        Exit Function
    Else
        Apci8308wGetLastError = Apci8308GetLastError(wLogSlot)
    End If
End Function
'============================================================================
'    VAʐMJn
'    wLogSlot       foCX̘_Xbgԍ
'        wCh            gp`l
'        pMode          샂[hi[Ă̈
' ߂l  True
'        s False
'============================================================================
Public Function Apci8308wSioStart(ByVal wLogSlot As Integer, ByVal wCh As Integer, ByRef pMode As SIOMODE) As Boolean
    Apci8308wSioStart = False
    If hDLL = 0 Then Exit Function
    If Apci8308SioStart(wLogSlot, wCh, pMode) = 0 Then Exit Function
    Apci8308wSioStart = True
End Function
'============================================================================
'    ʐMXe[^X擾
'    wLogSlot       foCX̘_Xbgԍ
'        wCh            gp`l
'        pStatus        Xe[^Xi[̈
' ߂l  True
'        s False
'============================================================================
Public Function Apci8308wSioGetStatus(ByVal wLogSlot As Integer, ByVal wCh As Integer, ByRef pStatus As SIOSTATUS) As Boolean
    Apci8308wSioGetStatus = False
    If hDLL = 0 Then Exit Function
    If Apci8308SioGetStatus(wLogSlot, wCh, pStatus) = 0 Then Exit Function
    Apci8308wSioGetStatus = True
End Function
'============================================================================
'    f[^M
'    wLogSlot       foCX̘_Xbgԍ
'        wCh            gp`l
'        pbData         Mf[^ۑ̈
'        dwDataSize     Mf[^
' ߂l  True
'        s False
'============================================================================
Public Function Apci8308wSioRead(ByVal wLogSlot As Integer, ByVal wCh As Integer, ByRef pbData() As Byte, ByVal dwDataSize As Long) As Boolean
    Apci8308wSioRead = False
    If hDLL = 0 Then Exit Function
    If Apci8308SioRead(wLogSlot, wCh, pbData(LBound(pbData)), dwDataSize) = 0 Then Exit Function
    Apci8308wSioRead = True
End Function
'============================================================================
'    f[^M
'    wLogSlot       foCX̘_Xbgԍ
'        wCh            gp`l
'        pbData         Mf[^̈
'        dwDataSize     Mf[^
' ߂l  True
'        s False
'============================================================================
Public Function Apci8308wSioWrite(ByVal wLogSlot As Integer, ByVal wCh As Integer, ByRef pbData() As Byte, ByVal dwDataSize As Long) As Boolean
    Apci8308wSioWrite = False
    If hDLL = 0 Then Exit Function
    If Apci8308SioWrite(wLogSlot, wCh, pbData(LBound(pbData)), dwDataSize) = 0 Then Exit Function
    Apci8308wSioWrite = True
End Function
'============================================================================
'    obt@̃Zbg
'    wLogSlot       foCX̘_Xbgԍ
'        wCh            gp`l
' ߂l  True
'        s False
'============================================================================
Public Function Apci8308wSioReset(ByVal wLogSlot As Integer, ByVal wCh As Integer) As Boolean
    Apci8308wSioReset = False
    If hDLL = 0 Then Exit Function
    If Apci8308SioReset(wLogSlot, wCh) = 0 Then Exit Function
    Apci8308wSioReset = True
End Function
'============================================================================
'    VAʐM~
'    wLogSlot       foCX̘_Xbgԍ
'        wCh            gp`l
' ߂l  True
'        s False
'============================================================================
Public Function Apci8308wSioStop(ByVal wLogSlot As Integer, ByVal wCh As Integer) As Boolean
    Apci8308wSioStop = False
    If hDLL = 0 Then Exit Function
    If Apci8308SioStop(wLogSlot, wCh) = 0 Then Exit Function
    Apci8308wSioStop = True
End Function
'----------------------------------------------------------------------------
'    DLL߰Ċ֐ڽ̎擾
'    
' ߂l  True
'        s False
'----------------------------------------------------------------------------
Private Function Apci8308wGetDllExportFunc() As Boolean
    Dim pFunc As Long

    Apci8308wGetDllExportFunc = False

    pFunc = GetProcAddress(hDLL, "Apci8308GetVersion")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8308Create")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8308Close")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8308GetResource")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8308GetSwitchValue")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8308GetLastError")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8308SioStart")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8308SioGetStatus")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8308SioRead")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8308SioWrite")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8308SioReset")
    If pFunc = 0 Then Exit Function
    pFunc = GetProcAddress(hDLL, "Apci8308SioStop")
    If pFunc = 0 Then Exit Function

    ' SĂ DLL ߰Ċ֐ڽ擾nj
    Apci8308wGetDllExportFunc = True

End Function

