//===================================================================
// Apci8308w.h - wrapper for C/C++
//-------------------------------------------------------------------
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
#include "Apci8308.h"

#ifdef __cplusplus
extern "C"{
#endif

#define APCI8308_DLL_NAME		_T("Apci8308.dll")		// DLL t@C
#define APCI8308_ERR_WRAPDLL	((DWORD)-1)				// wrapper ֐G[

BOOL  Apci8308wDllOpen( void );
BOOL  Apci8308wDllClose( void );

BOOL  Apci8308wGetVersion( PDWORD pdwDllVer, PDWORD pdwDrvVer );
BOOL  Apci8308wCreate( PWORD pwLogSlot );
BOOL  Apci8308wClose( WORD wLogSlot );
BOOL  Apci8308wGetResource( WORD wLogSlot, PAPCI8308R pRes );
BOOL  Apci8308wGetSwitchValue( WORD wLogSlot, PDWORD pdwSwitchValue );
DWORD Apci8308wGetLastError( WORD wLogSlot );

BOOL  Apci8308wSioStart( WORD wLogSlot, WORD wCh, PSIOMODE pMode );
BOOL  Apci8308wSioGetStatus( WORD wLogSlot, WORD wCh, PSIOSTATUS pStatus );
BOOL  Apci8308wSioRead( WORD wLogSlot, WORD wCh, PBYTE pbData, DWORD dwDataSize );
BOOL  Apci8308wSioWrite( WORD wLogSlot, WORD wCh, PBYTE pbData, DWORD dwDataSize ); 
BOOL  Apci8308wSioReset( WORD wLogSlot, WORD wCh );
BOOL  Apci8308wSioStop( WORD wLogSlot, WORD wCh );

#ifdef __cplusplus
}
#endif
